<script class='controller'>
    setTimeout(function() {

        /*           ACTUALIZAR CONTADORES               */
        $(document).off('click', "#updateCharts");
        $(document).on('click', '#updateCharts', function(e) {
            var userIntel = JSON.parse(window.localStorage.getItem("userIntel")),
                panelToShow = userIntel.panelUsuario,
                userId = $('#sidebarLoaded').attr('userIdPanel');
            $("#loading").fadeIn("fast", function() {
                showPanel(panelToShow, userId);
            });
        });

        /*           ACTUALIZAR CONTADORES               */
        $(document).off('click', "a.header-brand.changePanel");
        $(document).on('click', 'a.header-brand.changePanel', function(e) {
            e.preventDefault();
            e.stopImmediatePropagation();
        });
        $('a.header-brand.changePanel').removeClass('changePanel');

        /** CUANDO INICIA EL MODULO CARGAMOS LAS PRIMERAS TARJETAS */
        $('.anim1').velocity("transition.slideUpBigIn", {
            stagger: 250,
            complete: function() {

            }
        });

        $(document).off('click', ".getNewPicking button");
        $(document).on('click', '.getNewPicking button', function(e) 
		{
            getThisPick();
        });

		/* DETECTAR ENTER EN EL INGRESO DE LA FACTURA Y EJECUTAR ACCION*/
		$(document).find('#boxidpicking').keypress(function(e) {
            if (e.which == 13) {

                var devolVal = $(document).find('#boxidpicking').val();
                if (devolVal == '') {
                    $.growl.error({
                        message: "Debe ingresar la Factura"
                    });
                    return;
                }
				
                getThisPick();
            }
        });
		
        /** LE RESTAMOS 1 UNIDAD AL LISTADO SELECCIONADO */
        $(document).off('click', ".restarUnidad");
        $(document).on('click', '.restarUnidad', function(e) {

            var codigoBarrasDevuelto = $(this).parent().parent().parent().find('.codigoBarrasDevuelto').html(),
                unidTotales = $(this).parent().parent().parent().find('.unidTotales').html(),
                isListed = 0,
                unidXDevolver = $(this).parent().parent().parent().find('.unidXDevolver').html(),
				numlinea = $(this).parent().parent().parent().find('.NumLineaDevuelto').html();

            $(document).find('.listadoPicking tbody tr').each(function(i, n) {
                var codbarras = $(n).find('.codbarras').html(),
                    numlin = $(n).find('.numlin').html(),
                    supedido = $(n).find('.supedido').html(),
                    unidadesLeidas = $(n).find('.unidadesLeidas').html(),
                    unidades = $(n).find('.unidades').html();

                if (codbarras == codigoBarrasDevuelto && isListed == 0 && unidadesLeidas != 0 && numlin == numlinea) {
                    isListed = 1
                    restantes = +unidadesLeidas - 1;
                    $(n).find('.unidadesLeidas').html(restantes.toFixed(0));
                    $(n).removeClass('fullyReadPicki');
                    $(n).slideDown('slow');
                }

            });

            var totalEscan = $('.unidadesEscaenadasTotal span').html();
            console.log(totalEscan);
            totalEscan = +totalEscan - 1;
            $('.unidadesEscaenadasTotal span').html(totalEscan);
            console.log(totalEscan);
            unidXDevolver--;
            if (unidXDevolver == 0) {
                $(this).parent().parent().parent().parent().remove();
                return;
            }
            var newPropor = (+unidXDevolver * 100) / +unidTotales
            $(this).parent().parent().parent().find('.unidXDevolver').html(unidXDevolver);
            $(this).parent().parent().parent().find('.unidXDevolverPropor').attr('style', 'width: ' + newPropor.toFixed(0) + '%');

        });

        /** ELIMINAMOS EL LISTADO SELECCIONADO */
        $(document).off('click', ".eliminarUnidades");
        $(document).on('click', '.eliminarUnidades', function(e) {

            var codigoBarrasDevuelto = $(this).parent().parent().parent().find('.codigoBarrasDevuelto').html(),
                unidTotales = $(this).parent().parent().parent().find('.unidTotales').html(),
                isListed = 0,
                unidXDevolver = $(this).parent().parent().parent().find('.unidXDevolver').html(),
				numlinea = $(this).parent().parent().parent().find('.NumLineaDevuelto').html();

            $(document).find('.listadoPicking tbody tr').each(function(i, n) {
                var codbarras = $(n).find('.codbarras').html(),
                    numlin = $(n).find('.numlin').html(),
                    supedido = $(n).find('.supedido').html(),
                    unidadesLeidas = $(n).find('.unidadesLeidas').html(),
                    unidades = $(n).find('.unidades').html();
					

                if (codbarras == codigoBarrasDevuelto && isListed == 0 && numlin == numlinea) {
                    isListed = 1
                    restantes = +unidadesLeidas - +unidXDevolver;
                    $(n).find('.unidadesLeidas').html(restantes.toFixed(0));
                    $(n).removeClass('fullyReadPicki');
                    $(n).slideDown('slow');
                }

            });



            var totalEscan = $('.unidadesEscaenadasTotal span').html();
            totalEscan = +totalEscan - +unidXDevolver;
            $('.unidadesEscaenadasTotal span').html(totalEscan);
            $(this).parent().parent().parent().parent().remove();
            return;
        });
	
		
	/// CONSULTAMOS LA DISPONIBILIDAD DE STOCK/
       $(document).off('click', ".readerPistolBox_t button.envi");
        $(document).on('click', '.readerPistolBox_t button.envi', function(e) {
            
			var formData = new FormData(),
                codbarras = $(document).find('#productoBox').val(),
                codubic = $(document).find('#locationBoxf').val(),
				tipo = "U";
			var cajaM = '0000';
			
			formData.append('CodProd', codbarras);
			formData.append('UbicCod', codubic);
			formData.append('CodCajaM', cajaM);
			formData.append('meth', 'consultarUbiXCod');
			
			apiCall(formData, function(data) {
		   //   alert(JSON.stringify(data));
				if (data.status == "ERROR") {
					$.growl.error({
						message: "ERROR al validar ubicaciòn y CodBarras",
						duration: 6000
					});
					$(document).find('#locationBox').val('');
					$(document).find('#locationBox').focus();
				
				}else if(data.status == "T"){
					
					//alert(data.stock);
					//alert(JSON.stringify(data));
					getThisProd(data.stock);
					
				}else {

					$.growl.error({
						message: data.msg,
						duration: 6000
					});
					
					$(document).find('#locationBox').focus();
				}
			});
        });
		
		
		$('.productoBoxInp_t').keypress(function(e) {
			
            if (e.which == 13) {
			var formData = new FormData(),
                codbarras = $(document).find('#productoBox').val(),
                codubic = $(document).find('#locationBoxf').val(),
				tipo = "U";
				var cajaM = '0000';
				
				// alert(bod); 
           
                formData.append('CodProd', codbarras);
				formData.append('UbicCod', codubic);
				formData.append('CodCajaM', cajaM);
				formData.append('meth', 'consultarUbiXCod');
			
				apiCall(formData, function(data) {
                 // alert(JSON.stringify(data));
                    if (data.status == "ERROR") {
						$.growl.error({
							message: "ERROR al validar ubicaciòn y CodBarras",
							duration: 6000
						});
						$(document).find('#locationBox').val('');
						$(document).find('#locationBox').focus();
						
					}else if(data.status == "T"){
						
						//alert(data.stock);
						//alert(JSON.stringify(data));
						getThisProd(data.stock);
						
					}else {

						$.growl.error({
							message: data.msg,
							duration: 6000
						});
						
						$(document).find('#locationBox').focus();
					}
                });
        }});
        /** GUARDAMOS LA  DEVOLUCION */
        $(document).off('click', "#saveNewPickingft");
        $(document).on('click', '#saveNewPickingft', function(e) {

			//alert("Accion iniciada");
			
            var rowsCount = 0,
                devoldetail = [],
                userId =  $('#sidebarLoaded').attr('userIdPanel'),	
                carritonBox = $('#boxidpicking').val();
           
			 
            $(document).find('.porDevolInfoBox').each(function(i, n) {
				var idtransaccion = (Date.now());
				
                $(n).find('.thisReadDevol tbody tr').each(function(ii, nn) {
                   
                    var devolRow = {};
                    devolRow.codbarras = $(nn).find('.codbarras').html();
                    devolRow.numlin = $(nn).find('.numlin').html();
                    devolRow.supedido = $(nn).find('.supedido').html();
                    devolRow.unidades = $(n).find('.numleido').html();
                    devolRow.usuario = userId;
                    devolRow.carrito = carritonBox;
                    devolRow.codarticulo = $(nn).find('.codarticulo').html();
					devolRow.talla = $(nn).find('.talla').html();
					devolRow.color = $(nn).find('.color').html();
					devolRow.idtransaccion = idtransaccion;
				    devolRow.idlinea = rowsCount;
					devolRow.ubicacion = $(nn).find('.ubicacion').html();
					devolRow.codalmacen = $(nn).find('.codalmacen').html();
                    devoldetail.push(devolRow);
					rowsCount++;
                });
            });
		//	alert(rowsCount);
		//alert("Documento preparado, Total de lineas:".rowsCount);
		
            if (rowsCount > 0) {
                  
                $(this).velocity("transition.slideUpOut", {
                    duration: 200,
					
                    complete: function() {
						
                        $('#saveNewPickingFaket').velocity("transition.slideUpIn", {
                            duration: 200,
                            complete: function() {
								
                                var formData = new FormData(),
                                    userId = $('#sidebarLoaded').attr('userIdPanel');
									
                                formData.append('userDevol', userId);
								formData.append('pckf', JSON.stringify(devoldetail));	
					            formData.append('devol', JSON.stringify(devoldetail));
								formData.append('meth', 'saveNewPickingf');
                                apiCall(formData, function(data) {
								//alert("Servicio invocado");
								//alert(bod);
							   //alert(JSON.stringify(data));
                                    console.log(data);
                                    if (data.status == "saved") {
										//alert("Result: SAVED");
                                        $('.anim3,.porDevolInfoBox,#saveNewPickingFaket').velocity("transition.slideUpOut", {
                                            duration: 200,
                                            complete: function() {
                                                swal({
                                                    title: "Felicitaciones",
                                                    text: "Su Picking ha sido registrado en el sistema exitosamente.",
                                                    type: "success",
                                                    showCancelButton: false,
                                                    confirmButtonText: 'Entendido',
                                                    cancelButtonText: 'salir'
                                                }, function(isConfirm) {
													window.location.reload();
                                                    $(document).find('#sidebarLoaded > li:nth-child(1) > a').click();
                                                });
                                                $('.porDevolInfoBox').remove();
                                                $('.anim11,#saveNewDevol').velocity("transition.slideUpIn", {
                                                    duration: 200
                                                })
                                            }
                                        });
                                    } else {
                                        $('#saveNewPickingFaket').velocity("transition.slideUpOut", {
                                            duration: 200,
                                            complete: function() {
                                                swal({
                                                    title: "Lo Sentimos",
                                                    text: "Hubo un problema para guardar sus datos, intente de nuevo",
                                                    type: "error",
                                                    showCancelButton: false,
                                                    confirmButtonText: 'Entendido',
                                                    cancelButtonText: 'salir'
                                                });
                                                $('#saveNewDevol').velocity("transition.slideUpIn", {
                                                    duration: 200
                                                })
                                            }
                                        });
                                    }
                                });

                            }
                        });
                    }
                });
            } else {
                if (carritonBox == '0000') {

                    var devolRow = {};
                    devolRow.codbarras = '';
                    devolRow.numlin = '';
                    devolRow.supedido = $(document).find('.ordenTitleNumbr').html();
                    devolRow.unidades = '';
                    devolRow.usuario = userId;
                    devolRow.carrito = carritonBox;

                    devoldetail.push(devolRow);

                    $(this).velocity("transition.slideUpOut", {
                        duration: 200,
                        complete: function() {
                            $('#saveNewPickingFaket').velocity("transition.slideUpIn", {
                                duration: 200,
                                complete: function() {
                                    var formData = new FormData(),
									    idpicking = $(document).find('#boxidpicking').val(),
                                        userId = $('#sidebarLoaded').attr('userIdPanel');
                                    formData.append('userDevol', userId);
									//alert("Aqui toy fake");
                                    formData.append('devol', JSON.stringify(devoldetail));
                                    formData.append('meth', 'saveNewPickingf');
                                    apiCall(formData, function(data) {										
									//alert(bod);
									//alert(JSON.stringify(data));
                                        console.log(data);
                                        if (data.status == "saved") {
                                            $('.anim3,.porDevolInfoBox,#saveNewPickingFaket').velocity("transition.slideUpOut", {
                                                duration: 200,
                                                complete: function() {
                                                    swal({
                                                        title: "Información",
                                                        text: "Pedido Negado.",
                                                        type: "warning",
                                                        showCancelButton: false,
                                                        confirmButtonText: 'Entendido',
                                                        cancelButtonText: 'salir'
                                                    }, function(isConfirm) {
                                                        $(document).find('#sidebarLoaded > li:nth-child(1) > a').click();
                                                    });
                                                    $('.porDevolInfoBox').remove();
                                                    $('.anim11,#saveNewDevol').velocity("transition.slideUpIn", {
                                                        duration: 200
                                                    })
                                                }
                                            });
                                        } else {
                                            $('#saveNewPickingFaket').velocity("transition.slideUpOut", {
                                                duration: 200,
                                                complete: function() {
                                                    swal({
                                                        title: "Lo Sentimos",
                                                        text: "Hubo un problema para guardar sus datos, intente de nuevo",
                                                        type: "error",
                                                        showCancelButton: false,
                                                        confirmButtonText: 'Entendido',
                                                        cancelButtonText: 'salir'
                                                    });
                                                    $('#saveNewDevol').velocity("transition.slideUpIn", {
                                                        duration: 200
                                                    })
                                                }
                                            });
                                        }
                                    });

                                }
                            });
                        }
                    });
                } else {
                    $.growl.error({
                        message: "No hay productos leidos para recibir"
                    });
                }
            }

        });

        enterSubm();
    }, 1000);


    /** OBTENEMOS LOS DATOS DE LA ORDEN DE DEVOLUCION */
    function getThisPick() {
        $('#updateCharts i').addClass('fa-spin');
        var userId = $('#sidebarLoaded').attr('userIdPanel'),
		   idpicking = $(document).find('#boxidpicking').val(),		
		formData = new FormData();
           
		formData.append('userId', userId);
		formData.append('idpicking', idpicking);
		formData.append('meth', 'consultarPickingg');
        apiCall(formData, function(data) {
            $('#updateCharts i').removeClass('fa-spin');
            var resp = JSON.parse(data.resp.GetPickingDetaillResult);
            console.log(resp.pickingDetail);
            var dets = resp.pickingDetail;
            console.log(resp.pickingDetail);
            console.log(dets.length);
            if (resp.pickingDetail.length > 0) {
                $('.anim3').velocity("transition.slideUpBigOut", {
                    duration: 200,
                    complete: function() {
                        var code = '';
                        $('.listadoPicking tbody').html(code);
                        for (i = 0; i < resp.pickingDetail.length; i++) {
                            $('.listadoPicking tbody').append(' <tr class="thisPickingProd ' + resp.pickingDetail[i].numlin + ' '+ resp.pickingDetail[i].codbarras2 +' '+ resp.pickingDetail[i].codbarras3 +' '+ resp.pickingDetail[i].codbarras +'">' +
                                '<td class="fechapedido offscreen" data-valtype="fechapedido">' + resp.pickingDetail[i].fechapedido + '</td>' +
                                '<td class="supedido offscreen" data-valtype="supedido">' + resp.pickingDetail[i].supedido + '</td> ' +
                                '<td class="nombrecliente offscreen" data-valtype="nombrecliente">' + resp.pickingDetail[i].nombrecliente + '</td> ' +
                                '<td class="codbarras" data-valtype="codbarras">' + resp.pickingDetail[i].codbarras + '</td> ' +
								'<td class="unidades" data-valtype="unidades">' + resp.pickingDetail[i].unidades + '</td> ' +
								'<td class="stock" data-valtype="stock">' + resp.pickingDetail[i].stock + '</td> ' +
								'<td class="unidadesLeidas" data-valtype="unidadesLeidas">0</td> ' +
								'<td class="ubicacion" data-valtype="ubicacion">' + resp.pickingDetail[i].ubicacion + '</td> ' +
								'<td class="numlin" data-valtype="numlin">' + resp.pickingDetail[i].numlin + '</td> ' +
                                '<td class="referencia" data-valtype="referencia">' + resp.pickingDetail[i].referencia + '</td> ' +
                                '<td class="descripcion" data-valtype="descripcion">' + resp.pickingDetail[i].descripcion + '</td> ' +
                                '<td class="tc" data-valtype="tc">' + resp.pickingDetail[i].tc + '</td> ' +
                                '<td class="codbarras3" data-valtype="codbarras2">' + resp.pickingDetail[i].codbarras2 + '</td> ' +
								'<td class="codbarras2 codbarras2" data-valtype="codbarras3">' + resp.pickingDetail[i].codbarras3 + '</td> ' +
								'<td class="codfabricante codfabricante" data-valtype="codfabricante">' + resp.pickingDetail[i].codfabricante + '</td> ' +
								'<td class="offscreen color" data-valtype="color">' + resp.pickingDetail[i].color + '</td> ' +
								'<td class="offscreen codarticulo" data-valtype="codarticulo">' + resp.pickingDetail[i].codarticulo + '</td> ' +
								'<td class="offscreen talla" data-valtype="talla">' + resp.pickingDetail[i].talla + '</td> ' +
								'<td class="offscreen codalmacen" data-valtype="codalmacen">' + resp.pickingDetail[i].codalmacen + '</td> ' +
                                ' </tr>');
                            $('.ordenTitleNumbr').html(resp.pickingDetail[i].supedido);
                            $('.ordenTitleDate').html(resp.pickingDetail[i].fechapedido);
                            $('.ordenTitleClient').html(resp.pickingDetail[i].nombrecliente);
							$('.ordenTitleObs').html(resp.pickingDetail[i].obs);
                        }
                        $('.anim11').velocity("transition.slideUpBigOut", {
                            stagger: 250,
                            complete: function() {
                                $('.anim3').velocity("transition.slideUpBigIn", {
                                    stagger: 250,
                                    complete: function() {
                                        $('#cajamasterBox').focus();
                                    }
                                });
                            }
                        });
                    }
                });
            } else {
				
                $.growl.error({
                    message: "No existen documentos por procesar"
                });
                return;
            }
        });
    }
/// mostramos la foto del prodcuto
        
        $(document).off('click', ".thisPickingProd");
        $(document).on('click', '.thisPickingProd', function(e) {
            $('.refreshPageIcon').addClass('fa-spin');
            var formData = new FormData(),
                codbarras = $(this).find('.codbarras').html(),
                referencia = $(this).find('.referencia').html(),
				color = $(this).find('.color').html(),
				descripcion = $(this).find('.descripcion').html(),
                
				img = 'https://agora.com.gt/tta/assets/syncimgs/prods/'+referencia+'-'+color+'-1.jpg'
			     
			formData.append('codbarras', codbarras);
            formData.append('referencia', referencia);
            formData.append('meth', 'consultarimg');
		//	alert(img);
            apiCall(formData, function(data) {
                console.log(data);

                if (data.rows.length > 0) {
                    $('.boxProductInfoView').slideUp(800, function() {
                        var oldCod = $('.viewThisProdNumbr').html();
                        if (oldCod == codbarras) {
                            $('.refreshPageIcon').removeClass('fa-spin');
                            return;
                        }
                        $('.viewThisProdNumbr').html(descripcion);
                        $('.listadoUbics tbody').html('');
                        $(data.rows).each(function(i, n) {
                            $('.listadoUbics tbody').append(' <tr class="thisUBicProd">' +
                                '<td class="b3"><figure><img src='+img+' width="230" height="200" align="middle"></figure>  </td>'+
                                ' </tr>');
                        });
                        $('.boxProductInfoView').slideDown(800, function() {
                            $('.refreshPageIcon').removeClass('fa-spin');
                        });
                    });
                } else {
                    $.growl.error({
                        message: "Este producto no devolvio ubicaciones registradas"
                    });
                    return;
                }
            });
        });
		
	  enterSubm();	
	  
        /** OMSTRAMOS LAS UBICACIOEN SDEL PRODUCTO */
        $(document).off('click', ".thisPickingProd");
        $(document).on('click', '.thisPickingProd', function(e) {
            $('.refreshPageIcon').addClass('fa-spin');
            var formData = new FormData(),
                codBar = $(this).find('.codigoBarras').html(),
                codarticulo = $(this).find('.codarticulo').html(),
                talla = $(this).find('.talla').html(),
                suPedido = $(this).find('.suPedido').html(),
                color = $(this).find('.color').html();

            formData.append('codarticulo', codarticulo);
            formData.append('talla', talla);
            formData.append('color', color);
            formData.append('meth', 'consultarUbicxf');
            apiCall(formData, function(data) {
               
				console.log(data);

                if (data.rows.length > 0) {
                    $('.boxProductInfoViewxf').slideUp(800, function() {
                        var oldCod = $('.viewThisProdNumbrxf').html();
                        if (oldCod == codBar) {
                            $('.refreshPageIcon').removeClass('fa-spin');
                            return;
                        }
                        $('.viewThisProdNumbrxf').html(codBar);
                        $('.listadoUbicsxf tbody').html('');
                        $(data.rows).each(function(i, n) {
                            $('.listadoUbicsxf tbody').append(' <tr class="thisUBicProd">' +
                                
                                '<td class="CODUBICACION" data-valtype="CODUBICACION">' + n[1] + '</td> ' +
								'<td class="STOCK" data-valtype="STOCK">' + n[2] + '</td> ' +
                                ' </tr>');
                        });
                        $('.boxProductInfoViewxf').slideDown(800, function() {
                            $('.refreshPageIcon').removeClass('fa-spin');
                        });
                    });
                } else {
                    $.growl.error({
                        message: "Este producto no devolvio ubicaciones registradas"
                    });
                    return;
                }
            });
        });
        enterSubm();
		
		
		 /** CONSULTAMOS LA UBICAION SI EXISTE*/
        //$(document).off('change', "#locationBoxf");
		$(document).find('#locationBoxf').keypress(function(e) {
			if (e.which == 13) {
				//alert("Enter");
				$(document).find('#productoBox').focus();
			}
		});
		
        //$(document).on('keypress', "#locationBoxf", function(e) {
			//alert("CambiandoValor");
			
            /*var formData = new FormData(),
                codUbi = $(document).find('#locationBoxf').val();
				bod = $(n).find('.codalmacen').html();
				alert(bod);
				//bod = $(document).find('#selectBodegaPls').val();
            formData.append('codUbi', codUbi);
			formData.append('bod', bod);
            formData.append('meth', 'consultarUbic');
            apiCall(formData, function(data) {
				//alert(JSON.stringify(data));
                console.log(data);
                if (data.status == "gotProd") {
               //     $(document).find('#saveNewDevol').removeAttr('disabled');
					$(document).find('#productoBox').focus();
                } else {
                    $.growl.error({
                        message: "Codigo de Ubicacion no existe en el sistema ",
                        duration: 6000
                    });
                    $(document).find('#locationBoxf').val('');
                    $(document).find('#locationBoxf').focus();
                }
            });*/
        //});
		
    /** AL LEER CON PISTOLA UN CODIGO DE BARRA */
    function getThisProd(total) {
		
        var codbar = $(document).find('#productoBox').val(),
            codubic = $(document).find('#locationBoxf').val(),
			
            isInvoked = 0,
            isListed = 0,
            isPresent = 0,
			isPresentedTable = 0;
			
        $(document).find('.listadoPicking tbody tr').not('.fullyReadPicki').each(function(i, n) {
			
            var codbarras = $(n).find('.codbarras').html(),
			    codbarras3 = $(n).find('.codbarras3').html(),
				codbarras2 = $(n).find('.codbarras2').html(),
                numlin = $(n).find('.numlin').html(),
                supedido = $(n).find('.supedido').html(); 
				
            var unidadesLeidas = $(n).find('.unidadesLeidas').html(),
                unidades = $(n).find('.unidades').html(),
				color = $(n).find('.color').html();
				
			var	codarticulo = $(n).find('.codarticulo').html(),
				talla = $(n).find('.talla').html(),
				codalmacen = $(n).find('.codalmacen').html();
				
					

           // if (codbarras == codbar && isPresent == 0) {
			if ((codbarras == codbar && isPresent == 0) || (codbarras3 == codbar && isPresent == 0) || (codbarras2 == codbar && isPresent == 0)) {
                
				isPresent = 1;
				
                $(document).find(".cod_"+codbarras).each(function(ii, nn) {
					
                    var codigoBarrasDevuelto = $(nn).find('.codigoBarrasDevuelto').html();
					
					var numlinDevuelto = '';
					var uniLeidasActual = 0;
					var ubiLeidaActual = '';
					var leidasTotalActual = 0;
					
										
					$(document).find('.thisReadDevol_'+codbarras+' tbody').children('tr').each(function(x,yy){
						numlinDevuelto = $(yy).find('.numlin').html();
						uniLeidasActual = parseInt($(yy).find('.numleido').html());
						ubiLeidaActual = $(yy).find('.ubicacion').html();
						
						if($(yy).find('.codbarras').html() == codbarras && ubiLeidaActual == codubic && uniLeidasActual >= total ){
							
							isInvoked = 1;
							isPresentedTable = 1;
							$.growl.error({
								message: "Sin mas stock en la ubicacion: "+codubic
							});
														
						}
						else if($(yy).find('.codbarras').html() == codbarras && numlinDevuelto == numlin && ubiLeidaActual == codubic && total >= uniLeidasActual) {
					
							isInvoked = 1;
							var unidXDevolver = $(nn).find('.'+codbarras+numlinDevuelto+'.unidXDevolver').html();
							
							if (+unidXDevolver < +unidades ) {
								
								unidXDevolver++;
								var newPropor = (+unidXDevolver * 100) / + unidades;
								$(nn).find('.unidXDevolver').html(unidXDevolver);
								$(n).find('.unidadesLeidas').html(unidXDevolver);
								$(nn).find('.unidXDevolverPropor').attr('style', 'width: ' + newPropor.toFixed(0) + '%');
								if (+unidXDevolver == +unidades) {
									$(nn).find('.card').addClass('bg-info text-white');
									$(document).find('.card.cod_'+codbarras).addClass('bg-info text-white');
									$(document).find('.thisPickingProd.'+codbarras+'.'+numlinDevuelto).addClass('fullyReadPicki');
									$(n).slideUp('slow');
								}
								var totalEscan = $('.unidadesEscaenadasTotal span').html();
								totalEscan++;
								$('.unidadesEscaenadasTotal span').html(totalEscan);
								$(yy).find('.numleido').html(unidXDevolver);
							} else {
								$.growl.error({
									message: "No puedes exceder el límite de la Orden"
								});
							}
						}
						else if($(yy).find('.codbarras').html() == codbarras && codubic != $(yy).find('.ubicacion').html()){
							//alert("SE DEBE AÑADIR UNA LINEA A LA TABLA DETALLE");
							isInvoked = 2;
						}						
					});
                    
                });
				
				if(isInvoked == 2 && isPresentedTable == 0){
					
					//alert("SE DEBE AÑADIR UNA LINEA A LA TABLA PRINCIPAL");
					var stringAdd = '<tr><td class="text-dark codbarras text-center">'+codbarras+'</td>';
					stringAdd += '<td class="text-dark numlin text-center">' + numlin + '</td>';
					stringAdd += '<td class="text-dark numleido '+codbar+'_'+codubic+' text-center">1</td>';
					stringAdd += '<td class="text-dark supedido text-center ">' + supedido + '</td>';
					stringAdd += '<td class="text-dark codarticulo text-center ">' + codarticulo + '</td>';
					stringAdd += '<td class="text-dark talla text-center ">' + talla + '</td>';
					stringAdd += '<td class="text-dark color text-center ">' + color + '</td>';
					stringAdd += '<td class="text-dark ubicacion text-center ">' + codubic + '</td>';
					stringAdd += '<td class="text-dark codalmacen text-center ">' + codalmacen + '</td></tr>';
					//alert(stringAdd);
					
					$(document).find('.thisReadDevol_'+codbarras).append(stringAdd);
					
					var unidXDevolver = $(document).find('.'+codbarras+numlin+'.unidXDevolver').html();
								
					if (+unidXDevolver < +unidades ) {
						
						unidXDevolver++;
						
						var newPropor = (+unidXDevolver * 100) / +unidades;
						
						$(document).find('.'+codbarras+numlin+'.unidXDevolver').html(unidXDevolver);
						
						$(document).find('.'+codbarras+'.unidXDevolverPropor').attr('style', 'width: ' + newPropor.toFixed(0) + '%');
						
						if (+unidXDevolver == +unidades) {
							
							$(document).find('.card.cod_'+codbarras).addClass('bg-info text-white');
							$(document).find('.thisPickingProd.'+codbarras+'.'+numlin).addClass('fullyReadPicki');
							$(document).find('.thisPickingProd.'+codbarras).slideUp('slow');
							
						}
						var totalEscan = $('.unidadesEscaenadasTotal span').html();
						totalEscan++;
						$('.unidadesEscaenadasTotal span').html(totalEscan);
						
					} else {
						$.growl.error({
							message: "No puedes exceder el límite de la Orden"
						});
					}
					
					
				}
                if (isInvoked == 0) {
					
					//alert("AÑADIENDO TABLA");
                    var newPropor = 100 / +unidades;
                    var fullCard = '';
                    if (unidades == 1) {
                        fullCard = 'bg-info text-white';
                        $(n).addClass('fullyReadPicki');
                        $(n).slideUp('slow');
                    }
                    var invoke = `
                        <div class="col-sm-12 col-lg-12 col-xl-6 porDevolInfoBox">
                            <div class="card anim cod_` + codbarras + ` ` + fullCard + `">
                                <div class="card-header">
                                    <div class="card-title"><i class="fa fa-barcode "></i><strong class="NumLineaDevuelto">` + numlin + `</strong>-<strong class=" codigoBarrasDevuelto">` + codbarras + `</strong></div>
                                    <div class="card-options ">
                                        <span class="btn btn-info mr30 float-left restarUnidad"><i class="fa fa-minus"></i> </span>
                                        <span class="btn btn-join text-white float-left pull-left mr10 eliminarUnidades"><i class="fa fa-times  "></i> </span>
                                    </div>
                                </div>
                                <div class="table-responsive">
                                    <table class="table table-bordered border-top card-table table-vcenter text-nowrap table-primary thisReadDevol thisReadDevol_`+codbarras +` ">
                                        <thead class="bg-info text-white text-center">
                                            <tr>
                                                <th class="text-white">Producto</th>
                                                <th class="text-white">NumLin</th>
												<th class="text-white">Leido</th>
                                                <th class="text-white">supedido</th>
												<th class="text-white">codarticulo</th>
												<th class="text-white">talla</th>
												<th class="text-white">color</th>
												<th class="text-white">ubicacion</th>
												<th class="text-white">codalmacen</th>
                                            </tr>
                                        </thead>
                                        <tbody>
                                            <tr>
                                                <td class="text-dark codbarras text-center">` + codbarras + `</td>
                                                <td class="text-dark numlin text-center">` + numlin + `</td>
												<td class="text-dark numleido ` + codbar+`_`+codubic + `text-center">1</td>
                                                <td class="text-dark supedido text-center ">` + supedido + `</td>
												<td class="text-dark codarticulo text-center ">` + codarticulo + `</td>
												<td class="text-dark talla text-center ">` + talla + `</td>
												<td class="text-dark color text-center ">` + color + `</td>
												<td class="text-dark ubicacion text-center ">` + codubic + `</td>
												<td class="text-dark codalmacen text-center ">` + codalmacen + `</td>
                                            </tr>
                                        </tbody>
                                    </table>
                                    <div class="offscreen "></div>
                                </div>
                                <div class="card-body">
                                    <div class="row">
                                        <div class="col text-center">
                                            <label class="tx-12">Unidades Totales</label>
                                            <h2 class="font-weight-normal unidTotales">` + unidades + `</h2>
                                        </div>
                                        <div class="col border-left text-center">
                                            <label class="tx-12">Por Recibir</label>
                                            <h2 class="font-weight-normal ` + codbarras + numlin + ` unidXDevolver">1</h2>
                                        </div>
                                    </div>
                                    <div class="progress mt-4">
                                        <div class="progress-bar progress-bar-striped progress-bar-animated bg-join ` + codbarras + ` unidXDevolverPropor" style="width: ` + newPropor + `%"></div>
                                    </div>
                                </div>
                            </div>
                        </div>
                        `;


                    var totalEscan = $('.unidadesEscaenadasTotal span').html();
                    totalEscan++;
                    $('.unidadesEscaenadasTotal span').html(totalEscan);
                    $(n).find('.unidadesLeidas').html('1');
                    $(invoke).insertAfter('.readerPistolBox_t');
                    $('.cod_' + codbarras).velocity("transition.slideUpBigIn", {
                        stagger: 250
                    });
                }
            }
        });
        if (isPresent == 0) {
            $.growl.error({
                message: "Este producto no se encuentra en la Orden "
            });
        }
		
		$(document).find('#locationBoxf').val('');
        $(document).find('#productoBox').val('');
        $(document).find('#locationBoxf').focus();

    }

   
</script>